<?php
//pm_lead_book
/*
	* functions.php
*/
add_action( 'plugins_loaded', 'pm_lead_book_load_textdomain' );
function pm_lead_book_load_textdomain() {
    load_plugin_textdomain( 'pm-lead-book', false, dirname( plugin_basename( __DIR__ ) ) . '/languages' );
}

/**
 * Flush rewrite rules for custom post type archive on single activation
 *
 * @since    0.0.1
 */
function pm_lead_book_install() {
	pm_lead_book_post_type_init();
	flush_rewrite_rules();
}

/*
	* pm_lead_book_deactivate
*/

function pm_lead_book_deactivate() {

}

/**
 * Register a post type.
 *
 * @link http://codex.wordpress.org/Function_Reference/register_post_type
 */
add_action( 'init', 'pm_lead_book_post_type_init' );
function pm_lead_book_post_type_init() {
	
}

/*
	* get current URL
*/
function pm_lead_book_get_current_url() {
	$curpageURL = 'http';
	if (isset($_SERVER["HTTPS"])) {
		$curpageURL.= "s";
	}
	$curpageURL.= "://";
	if ($_SERVER["SERVER_PORT"] != "80") {
		$curpageURL.= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	} 
	else {
		$curpageURL.= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	}
	return $curpageURL;
}

if( !function_exists('pm_ppp') ) {
	function pm_ppp($var) {
		print '<pre>';
		print_r($var);	
		print '</pre>';
	}
}

/*
	* pm_lead_book_settings_fields
	* Fields for Settings
*/
function pm_lead_book_setting_fields(){
	$fields = array(
	'facebook' => array(
		'social_name' => __( 'Facebook', 'pm-lead-book' ),
		'general_description' => __( 'Enter you Facebook Details', 'pm-lead-book' ),
		'fields' => array(
			'app_id' => array(
				'name' => 'app_id',
				'description' => __( 'Enter your Facebook AppID', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'App Id', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'app_secret' => array(
				'name' => 'app_secret',
				'description' => __( 'Enter your Facebook Secret Key', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'password',
				'label' => __( 'App Secret', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'token' => array(
				'name' => 'token',
				'description' => __( 'Access Token', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'hidden',
				'label' => __('Access Token', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			),
			'authorized' => array(
				'name' => 'authorized',
				'description' => __( 'If Social Authorized', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'hidden',
				'label' => __( 'Authorized', 'pm-lead-book' ),
				'default' => 0,
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			)
		)
	),
	'mailchimp' => array(
		'social_name' => __( 'MailChimp', 'pm-lead-book' ),
		'general_description' => __( 'Enter you MailChimp Details', 'pm-lead-book' ),
		'fields' => array(
			'app_id' => array(
				'name' => 'app_id',
				'description' => __( 'Enter MailChimp AppKey', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'password',
				'label' => __( 'MailChimp AppKey', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			)
		)
	),
	'aweber' => array(
		'social_name' => __( 'Aweber', 'pm-lead-book' ),
		'general_description' => __( 'Enter you Awever Details', 'pm-lead-book' ),
		'fields' => array(
			'consumer_key' => array(
				'name' => 'consumer_key',
				'description' => __( 'Enter Consumer Key', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'Consumer Key', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'consumer_secret' => array(
				'name' => 'consumer_secret',
				'description' => __( 'Enter your Consumer Secret', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'password',
				'label' => __( 'Consumer Secret', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'access_token' => array(
				'name' => 'access_token',
				'description' => __( 'Access Token', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'hidden',
				'label' => __('Access Token', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			),
			'access_token_secret' => array(
				'name' => 'access_token_secret',
				'description' => __( 'Access Token Secret', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'hidden',
				'label' => __('Access Token Secret', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			),
			'authorized' => array(
				'name' => 'authorized',
				'description' => __( 'If Social Authorized', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'hidden',
				'label' => __( 'Authorized', 'pm-lead-book' ),
				'default' => 0,
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			)
		)
	),
	'lead_form' => array(
		'social_name' => __( 'Form IDs', 'pm-lead-book' ),
		'general_description' => __( 'Enter Form IDs', 'pm-lead-book' ),
		'fields' => array(
			'facebook' => array(
				'name' => 'facebook',
				'description' => __( 'Enter your Facebook List ID', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'Facebook', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'mailchimp' => array(
				'name' => 'mailchimp',
				'description' => __( 'Enter your MailChimp List ID', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'MailChimp', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'aweber' => array(
				'name' => 'aweber',
				'description' => __( 'Enter your Aweber List ID', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'text',
				'label' => __( 'Aweber', 'pm-lead-book' ),
				'default' => '',
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
		)
	),
	'settings' => array(
		'social_name' => __( 'Cron Settings', 'pm-lead-book' ),
		'general_description' => __( '-', 'pm-lead-book' ),
		'fields' => array(
			'cron_time' => array(
				'name' => 'cron_time',
				'description' => __( 'Cron Interval', 'pm-lead-book' ),
				'field' => 'select',
				'type' => 'select',
				'label' => __( 'Cron Interval', 'pm-lead-book' ),
				'default' => 'hourly',
				'values' => array('hourly', 'twicedaily', 'daily' ),
				'repeatable' => false,
				'show_add' => false,
				'required' => true
			),
			'enable_mailchimp' => array(
				'name' => 'enable_mailchimp',
				'description' => __( 'Enable MailChimp Cron', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'checkbox',
				'label' => __( 'MailChimp', 'pm-lead-book' ),
				'default' => 0,
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			),
			'enable_aweber' => array(
				'name' => 'enable_aweber',
				'description' => __( 'Enable Aweber Cron', 'pm-lead-book' ),
				'field' => 'input',
				'type' => 'checkbox',
				'label' => __( 'Aweber', 'pm-lead-book' ),
				'default' => 0,
				'repeatable' => false,
				'show_add' => false,
				'required' => false
			),
		)
	),
	);
	
	return $fields;
}

/*
	* pm_pmover_setting_fields
	* Fields for Settings
*/
function pm_lead_book_set_field($attr,$social,$opt){
	$output = '';
	$values = pm_lead_book_setting_fields();
	if($attr == 'name') {
		$output = PM_LEAD_BOOK_SETTINGS_OPTION . "[{$social}]" . "[{$opt}]";
	} elseif($attr == 'id') {
		$output = PM_LEAD_BOOK_SETTINGS_OPTION . "_{$social}" . "_{$opt}";
	} else {
		$output = $values[$social]['fields'][$opt][$attr];
	}
	return $output;
}

/*
	Get Settings URL
*/

function pm_lead_book_settings_url() {
	$url = admin_url('admin.php?page=pm_lead_book_settings');
	return $url;
}

/*
	* Facebook Initialize
*/

function pm_lead_book_facebook_initialize() {
	require_once('libs/facebook/autoload.php');
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$error = true;
	$fb = '';
	
	if(is_array($creds)) {
		foreach($creds as $key => $cred) {
			if($setting_fields[$sn]['fields'][$key]['required']) {
			$error = (empty($cred) ? true : false );
			if($error) {break;}
			}
		}
	}
	
	if($error){
		//Variables to validate
	} else {
		$_SESSION[$sn.'_app_id'] = (string) $creds['app_id'];
		$_SESSION[$sn.'_app_secret'] = (string) $creds['app_secret'];
		$fb_user_tokken = (isset($creds['token']) ? $creds['token'] : '');
		if(empty($fb_user_tokken) && isset($_SESSION[$sn.'_access_token']) && !empty($_SESSION[$sn.'_access_token'])) {
			
			$options[$sn]['token'] = $_SESSION[$sn.'_access_token'];
			$options[$sn]['authorized'] = 1;
			update_option(PM_LEAD_BOOK_SETTINGS_OPTION, $options);
			$fb_user_tokken = $_SESSION['facebook_access_token'];
			unset($_SESSION['facebook_access_token']);
		}
		
		$fb = new Facebook\Facebook([
		  'app_id' => $creds['app_id'],
		  'app_secret' => $creds['app_secret'],
		  'default_graph_version' => 'v2.4',
		  'default_access_token' => (isset($fb_user_tokken) ? $fb_user_tokken : '')
		]);
	}
	return $fb;
}

/*
	* Facebook Connect
*/

function pm_lead_book_facebook_connect() {
	$fb = pm_lead_book_facebook_initialize();
	
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	
	if($fb):
		try {
			$current_user = $fb->get('/me');
			$user = $current_user->getGraphUser();
			?>
			<h3><?php print $setting_fields[$sn]['social_name']; ?></h3>
			<p><strong><?php esc_html(_e( 'Connected as: ', 'pm-lead-book' )); ?></strong> <?php print $user['name']; ?></p>
			<?php pm_lead_book_facebook_logout(); ?>
			<?php
		} catch(Facebook\Exceptions\FacebookResponseException $e) {
		//echo 'Graph returned an error: ' . $e->getMessage();
			$helper = $fb->getRedirectLoginHelper();
			$permissions = ['manage_pages','ads_management']; // optional
			$loginUrl = $helper->getLoginUrl(PM_LEAD_BOOK_DIR.'modules/libs/login/facebook-login.php', $permissions);
			$image_url = PM_LEAD_BOOK_DIR.'modules/src/images/login-'.$sn.'.png';
			echo '<p class="pm_lead_book_login_facebook"><a href="' . $loginUrl . '"><img src="'.$image_url.'" height="30" /></a></p>';
		} catch(Facebook\Exceptions\FacebookSDKException $e) {
			echo esc_html(sprintf(__('Facebook SDK returned an error: %s', 'pm-lead-book'),$e->getMessage()));
		}
	endif; //End $fb
}

/*
	* Facebook Logout
*/

function pm_lead_book_facebook_logout() {
	$sn = 'facebook';
	$logoutUrl = $_SERVER['REQUEST_URI']."&social={$sn}&logout=yes";
	$settings_url = pm_lead_book_settings_url();
	if(isset($_GET['logout']) && $_GET['logout'] == 'yes' && $_GET['social'] == $sn) {
	//$fb->get('/me/permissions','DELETE');
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$options[$sn]['token'] = '';
	$options[$sn]['authorized'] = 0;
	update_option(PM_LEAD_BOOK_SETTINGS_OPTION, $options);
	print $admin_url;
	echo "<script> window.location='{$settings_url}'; </script> ";
	}
	
	echo '<p><a href="' . $logoutUrl . '">'. esc_html(__( 'Logout Facebook: ', 'pm-lead-book' )) .'</a></p>';
}

/*
	* Facebook Logged-in Status
*/

function pm_lead_book_login_status() {
	$status = false;
	$fb = pm_lead_book_facebook_initialize();
	
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	
	if($fb):
		try {
			$current_user = $fb->get('/me');
			$status = true;
		} catch(Facebook\Exceptions\FacebookResponseException $e) {
		} catch(Facebook\Exceptions\FacebookSDKException $e) {
			
		}
	endif; //End $fb
	
	return $status;
}

/*
	* Aweber Initialize
*/

function pm_lead_book_aweber_initialize() {
	require_once('libs/aweber_api/aweber_api.php');
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'aweber';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$error = true;
	$aw = '';
	
	if(is_array($creds)) {
		foreach($creds as $key => $cred) {
			if($setting_fields[$sn]['fields'][$key]['required']) {
			$error = (empty($cred) ? true : false );
			if($error) {break;}
			}
		}
	}
	
	if($error){
		//Variables to validate

	} else {
		$_SESSION[$sn.'_consumer_key'] = (string) $creds['consumer_key'];
		$_SESSION[$sn.'_consumer_secret'] = (string) $creds['consumer_secret'];

		$aweber_consumer_key = (isset($creds['consumer_key']) ? $creds['consumer_key'] : '');
		$aweber_consumer_secret = (isset($creds['consumer_secret']) ? $creds['consumer_secret'] : '');
		
		$aweber_access_token = (isset($creds['access_token']) ? $creds['access_token'] : '');
		$aweber_access_token_secret = (isset($creds['access_token_secret']) ? $creds['access_token_secret'] : '');
		
		if(empty($aweber_access_token) && isset($_SESSION[$sn.'_access_token']) && !empty($_SESSION[$sn.'_access_token'])
			&& empty($aweber_access_token_secret) && isset($_SESSION[$sn.'_access_token_secret']) && !empty($_SESSION[$sn.'_access_token_secret'])
		) {
			$options[$sn]['access_token'] = $_SESSION[$sn.'_access_token'];
			$options[$sn]['access_token_secret'] = $_SESSION[$sn.'_access_token_secret'];
			$options[$sn]['authorized'] = 1;
			update_option(PM_LEAD_BOOK_SETTINGS_OPTION, $options);
			unset($_SESSION[$sn.'_access_token']);
			unset($_SESSION[$sn.'_access_token_secret']);
			$aw = true;
		}
		
		if(!empty($aweber_consumer_key) && !empty($aweber_consumer_secret) && !empty($aweber_access_token) && !empty($aweber_access_token_secret) ) {
			$aw = true;
		}
	}
	return $aw;
}

/*
	* Aweber Connect
*/

function pm_lead_book_aweber_connect() {
	$aw = pm_lead_book_aweber_initialize();	
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());	
	$sn = 'aweber';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$aweber_consumer_key = (isset($creds['consumer_key']) ? $creds['consumer_key'] : '');
	$aweber_consumer_secret = (isset($creds['consumer_secret']) ? $creds['consumer_secret'] : '');
	
	if($aw) {		
		
		$aweber_access_token = (isset($creds['access_token']) ? $creds['access_token'] : '');
		$aweber_access_token_secret = (isset($creds['access_token_secret']) ? $creds['access_token_secret'] : '');
		try {
			$aweber = new AWeberAPI($aweber_consumer_key, $aweber_consumer_secret);
			$account = $aweber->getAccount($aweber_access_token, $aweber_access_token_secret);
			if($account) { ?>
				<h3><?php print $setting_fields[$sn]['social_name']; ?></h3>
				<p><strong><?php esc_html(_e( 'Connected To Aweber', 'pm-lead-book' )); ?></strong></p>
				<?php pm_lead_book_aweber_logout(); ?>
			<?php
			}
		} catch(AWeberAPIException $exc) {
		    
		}
		
	} else {
		if( !empty($aweber_consumer_key) && !empty($aweber_consumer_secret) ) {
			$loginUrl = PM_LEAD_BOOK_DIR.'modules/libs/login/aweber-connect.php';
			print '<p class="pm_lead_book_login_aweber"><a class="btn btn-primary" href="' . $loginUrl . '">'.esc_html(__( 'Login with Aweber', 'pm-lead-book' )).'</a></p>';		
		}
	}

}

/*
	* Aweber Logged-in Status
*/

function pm_lead_book_aweber_login_status() {
	$status = false;
	$aw = pm_lead_book_aweber_initialize();	
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());	
	$sn = 'aweber';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	
	if($aw) {
		$aweber_consumer_key = (isset($creds['consumer_key']) ? $creds['consumer_key'] : '');
		$aweber_consumer_secret = (isset($creds['consumer_secret']) ? $creds['consumer_secret'] : '');
		
		$aweber_access_token = (isset($creds['access_token']) ? $creds['access_token'] : '');
		$aweber_access_token_secret = (isset($creds['access_token_secret']) ? $creds['access_token_secret'] : '');
		try {
			$aweber = new AWeberAPI($aweber_consumer_key, $aweber_consumer_secret);
			$account = $aweber->getAccount($aweber_access_token, $aweber_access_token_secret);
			$status = true;
		} catch(AWeberAPIException $exc) {
		    pm_lead_book_aweber_handle_errors($exc);
		}
		
	}
	
	return $status;
}

/*
	* Aweber Logout
*/

function pm_lead_book_aweber_logout() {
	$sn = 'aweber';
	$logoutUrl = $_SERVER['REQUEST_URI']."&social={$sn}&logout=yes";
	$settings_url = pm_lead_book_settings_url();
	if(isset($_GET['logout']) && $_GET['logout'] == 'yes' && $_GET['social'] == $sn) {
	
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$options[$sn]['access_token'] = '';
	$options[$sn]['access_token_secret'] = '';
	$options[$sn]['authorized'] = 0;
	update_option(PM_LEAD_BOOK_SETTINGS_OPTION, $options);
	print $admin_url;
	echo "<script> window.location='{$settings_url}'; </script> ";
	}
	
	echo '<p><a href="' . $logoutUrl . '">'. esc_html(__( 'Logout Aweber: ', 'pm-lead-book' )) .'</a></p>';
}


add_action( 'wp_ajax_pm_lead_book_ads_count_ajax', 'pm_lead_book_ads_count_callback' );

function pm_lead_book_ads_count_callback() {
	$next_link = trim($_POST['next_data']);
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$fb_user_tokken = (isset($creds['token']) ? $creds['token'] : '');
	$fb_app_id = (isset($creds['app_id']) ? $creds['app_id'] : '');
	$fb_app_secret = (isset($creds['app_secret']) ? $creds['app_secret'] : '');
	$facebook_form_id = (isset($options['lead_form']['facebook']) ? $options['lead_form']['facebook'] : '');
	$cursor = '';
	$query = "{$facebook_form_id}/leads";
	if(empty($next_link)) {
		$cursor = pm_lead_book_api_call($query,$fb_user_tokken);
	} else {
		$cursor = pm_lead_book_api_call($next_link,'',true);
	}
	
	$leads = $cursor->data;
	$next = (isset($cursor->paging->next) ? $cursor->paging->next : '');
	$count = 0;
	foreach( $leads as $lead ){
		$lead_data = pm_lead_book_process_lead_array($lead->field_data, $lead->id);
		$count++;
	}
	
	$time = date('m/d/Y');
	
	$data = array();
	$data['count'] = $count;
	$data['prev_link'] = $next_link;
	$data['next'] = $next;
	$data['date'] = $time;
	print json_encode($data);
	
	die(); // this is required to return a proper result
}

add_action( 'wp_ajax_pm_lead_book_ads_process_data_ajax', 'pm_lead_book_ads_process_data_callback' );

function pm_lead_book_ads_process_data_callback() {
	$mailchimp_api = PM_LEAD_BOOK_PATH."/modules/libs/mailchimp/Mailchimp.php";
	if(file_exists($mailchimp_api)) {
		require_once $mailchimp_api;
	}
	
	$aweber_api = PM_LEAD_BOOK_PATH."/modules/libs/aweber_api/aweber_api.php";
	if(file_exists($aweber_api)) {
		require_once $aweber_api;
	}

	$next_link = trim($_POST['next_data']);
	$process_type = trim($_POST['data_type']);
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$fb_user_tokken = (isset($creds['token']) ? $creds['token'] : '');
	$fb_app_id = (isset($creds['app_id']) ? $creds['app_id'] : '');
	$fb_app_secret = (isset($creds['app_secret']) ? $creds['app_secret'] : '');
	$facebook_form_id = (isset($options['lead_form']['facebook']) ? $options['lead_form']['facebook'] : '');
	$cursor = '';
	$query = "{$facebook_form_id}/leads";
	
	if(empty($next_link)) {
		$cursor = pm_lead_book_api_call($query,$fb_user_tokken);
	} else {
		$cursor = pm_lead_book_api_call($next_link,'',true);
	}
	
	$leads = $cursor->data;
	$next = (isset($cursor->paging->next) ? $cursor->paging->next : '');
	$count = 0;
	foreach( $leads as $lead ){
		$lead_data = pm_lead_book_process_lead_array($lead->field_data, $lead->id);
		$processed = pm_lead_book_add_subscriber($process_type,$lead_data);
		if($processed) {
			$count++;	
		}
	}
	
	$time = date('m/d/Y');
	
	$data = array();
	$data['count'] = $count;
	$data['prev_link'] = $next_link;
	$data['next'] = $next;
	$data['date'] = $time;
	$data['process_type'] = $process_type;
	print json_encode($data);
	
	die(); // this is required to return a proper result
}


/**
* Add Subscribers
* 
*/

function pm_lead_book_add_subscriber($type, $data_array) {
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$return = false;
	if( $type == 'mailchimp') {
		$mailchimp_appkey = (isset($options['mailchimp']['app_id']) ? $options['mailchimp']['app_id'] : '');
		$mailchimp_list_id = (isset($options['lead_form']['mailchimp']) ? $options['lead_form']['mailchimp'] : '' );
		
		$email = (isset($data_array['email']) ? $data_array['email'] : '');
		$fname = (isset($data_array['first_name']) ? $data_array['first_name'] : '');
		$lname = (isset($data_array['last_name']) ? $data_array['last_name'] : '');
		
		if($email) {
			$merge_vars = array();
			$new_data = array();
			
			$merge_vars = array('FNAME' => $fname, 'LNAME' => $lname);
			$Mailchimp = new Mailchimp($mailchimp_appkey);
			$Mailchimp_Lists = new Mailchimp_Lists($Mailchimp);
			try{
				$subscriber = $Mailchimp_Lists->subscribe(
					$mailchimp_list_id,
					array('email'=>htmlentities($email)),
					$merge_vars,
					false,
					false,
					false,
					false
				);
				$return = true;
			} catch(Mailchimp_Error $e){
				
			}
		}
		
	} elseif( $type == 'aweber' ) {
		$email = (isset($data_array['email']) ? $data_array['email'] : '');
		$fname = (isset($data_array['first_name']) ? $data_array['first_name'] : '');
		$lname = (isset($data_array['last_name']) ? $data_array['last_name'] : '');
		if( !empty($data_array['full_name']) ) {
			$full_name = $data_array['full_name'];
		} else {
			$full_name = $fname.' '.$lname;
		}
		
		
		$sn = 'aweber';
		$creds = (isset($options[$sn]) ? $options[$sn] : '');
		$aweber_consumer_key = (isset($creds['consumer_key']) ? $creds['consumer_key'] : '');
		$aweber_consumer_secret = (isset($creds['consumer_secret']) ? $creds['consumer_secret'] : '');
		$aweber_list_id = (isset($options['lead_form']['aweber']) ? $options['lead_form']['aweber'] : '');
		$aweber_access_token = (isset($creds['access_token']) ? $creds['access_token'] : '');
		$aweber_access_token_secret = (isset($creds['access_token_secret']) ? $creds['access_token_secret'] : '');
		
		if($email) {
			try {
				$aweber = new AWeberAPI($aweber_consumer_key, $aweber_consumer_secret);
				$aweber->adapter->debug = false;
				$account = $aweber->getAccount($aweber_access_token, $aweber_access_token_secret);
				$account_id = $account->id;
				$listURL = "/accounts/{$account_id}/lists/{$aweber_list_id}";

			    $list = $account->loadFromUrl($listURL);
				# create a subscriber
			    $params = array(
			        'email' => $email,
			        'name' => $full_name,
					'status' => 'subscribed',
					'subscription_method' => 'import'
			    );
			    $subscribers = $list->subscribers;
			    $new_subscriber = $subscribers->create($params);

			    # success!
			    $return = true;

			} catch(AWeberAPIException $exc) {
			    
			}
		}
		
	}
	return $return;
}


/*
	* CURL contents from graph API
*/

function pm_lead_book_api_call($query, $token, $next = false) {
		$ch = curl_init();
		if($next) {
			$url = $query;	
		} else {
			$api_url = 'https://graph.facebook.com/v2.8/';
			$url = $api_url.$query.'?limit=15&access_token='.$token;	
		}
		
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		//curl_setopt($ch,CURLOPT_USERAGENT,'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.13) Gecko/20080311 Firefox/2.0.0.13');
		$html = curl_exec($ch);
		$data = curl_exec($ch);
		curl_close($ch);
		$data =  json_decode( $data );
		return $data;
}

function pm_lead_book_process_lead_array($field_data, $data_id) {
	$data_array = array();
	$data_array['id'] = $data_id;
	$data_array['email'] = '';
	$data_array['full_name'] = '';
	$data_array['first_name'] = '';
	$data_array['last_name'] = '';
	
	foreach($field_data as $data){
		
		if($data->name == 'email') {
			$data_array['email'] = $data->values[0];
		}
		
		if($data->name == 'email') {
			$data_array['email'] = $data->values[0];
		}
		
		if($data->name == 'full_name') {
			$data_array['full_name'] = $data->values[0];
		}
		
		if($data->name == 'first_name') {
			$data_array['first_name'] = $data->values[0];
		}
		
		if($data->name == 'last_name') {
			$data_array['last_name'] = $data->values[0];
		}
		
	}
	
	return $data_array;
}

/**
* pm_lead_book_process_mailchimp_lead_ads_cron
* 
*/
$lead_form_options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
$lead_form_schedule = (isset($lead_form_options['settings']['cron_time']) ? $lead_form_options['settings']['cron_time'] : 0);
$lead_form_enable_mailchimp_cron = (isset($lead_form_options['settings']['enable_mailchimp']) ? $lead_form_options['settings']['enable_mailchimp'] : 0);
$lead_form_enablea_aweber_cron = (isset($lead_form_options['settings']['enable_aweber']) ? $lead_form_options['settings']['enable_aweber'] : 0);
$lead_form_schedule_time = time();
if($lead_form_schedule == 'hourly') {
	//array('hourly', 'twicedaily', 'daily' ),
	$lead_form_schedule_time = strtotime('+1 hour');
} elseif($lead_form_schedule == 'twicedaily') {
	$lead_form_schedule_time = strtotime('+12 hours');
} elseif($lead_form_schedule == 'daily') {
	$lead_form_schedule_time = strtotime('+1 day');
}

if($lead_form_enable_mailchimp_cron == 1) {
	if (! wp_next_scheduled ( 'pm_lead_book_process_mailchimp_lead_ads_cron' )) {
		$next_run = date("F j, Y, g:i a", $lead_form_schedule_time);
		update_option('_pm_lead_book_next_run_mailchimp', $next_run);
		wp_schedule_event($lead_form_schedule_time, $lead_form_schedule, 'pm_lead_book_process_mailchimp_lead_ads_cron');
	}
} else {
	wp_clear_scheduled_hook('pm_lead_book_process_mailchimp_lead_ads_cron');
}

add_action('pm_lead_book_process_mailchimp_lead_ads_cron', 'pm_lead_book_process_mailchimp_lead_ads_cron_callback');

function pm_lead_book_process_mailchimp_lead_ads_cron_callback() {
	$last_run = date("F j, Y, g:i a");
	update_option('_pm_lead_book_last_run_mailchimp', $last_run);
	pm_lead_book_ads_process_data_cron('mailchimp');
}

if($lead_form_enablea_aweber_cron == 1) {
	if (! wp_next_scheduled ( 'pm_lead_book_process_aweber_lead_ads_cron' )) {
		$next_run = date("F j, Y, g:i a", $lead_form_schedule_time);
		update_option('_pm_lead_book_next_run_aweber', $next_run);
		wp_schedule_event($lead_form_schedule_time, $lead_form_schedule, 'pm_lead_book_process_aweber_lead_ads_cron');
	}
} else {
	wp_clear_scheduled_hook('pm_lead_book_process_aweber_lead_ads_cron');
}

add_action('pm_lead_book_process_aweber_lead_ads_cron', 'pm_lead_book_process_aweber_lead_ads_cron_callback');

function pm_lead_book_process_aweber_lead_ads_cron_callback() {
	$last_run = date("F j, Y, g:i a");
	update_option('_pm_lead_book_last_run_aweber', $last_run);
	pm_lead_book_ads_process_data_cron('aweber');
}

function pm_lead_book_ads_process_data_cron($process_type, $next_link = '') {
	$mailchimp_api = PM_LEAD_BOOK_PATH."/modules/libs/mailchimp/Mailchimp.php";
	if(file_exists($mailchimp_api)) {
		require_once $mailchimp_api;
	}
	
	$aweber_api = PM_LEAD_BOOK_PATH."/modules/libs/aweber_api/aweber_api.php";
	if(file_exists($aweber_api)) {
		require_once $aweber_api;
	}

	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$fb_user_tokken = (isset($creds['token']) ? $creds['token'] : '');
	$fb_app_id = (isset($creds['app_id']) ? $creds['app_id'] : '');
	$fb_app_secret = (isset($creds['app_secret']) ? $creds['app_secret'] : '');
	$facebook_form_id = (isset($options['lead_form']['facebook']) ? $options['lead_form']['facebook'] : '');
	$cursor = '';
	$query = "{$facebook_form_id}/leads";
	
	if(empty($next_link)) {
		$cursor = pm_lead_book_api_call($query,$fb_user_tokken);
	} else {
		$cursor = pm_lead_book_api_call($next_link,'',true);
	}
	
	$leads = $cursor->data;
	$next = (isset($cursor->paging->next) ? $cursor->paging->next : '');
	$count = 0;
	foreach( $leads as $lead ){
		$lead_data = pm_lead_book_process_lead_array($lead->field_data, $lead->id);
		$processed = pm_lead_book_add_subscriber($process_type,$lead_data);
		if($processed) {
			$count++;	
		}
	}
	
	if($next) {
		pm_lead_book_ads_process_data_cron($process_type, $next);
	}
	
}


/**
* Generate Facebook Lead Download Link
* 
*/

function pm_lead_book_generate_link() {
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	$sn = 'facebook';
	$creds = (isset($options[$sn]) ? $options[$sn] : '');
	$fb_user_tokken = (isset($creds['token']) ? $creds['token'] : '');
	$fb_app_id = (isset($creds['app_id']) ? $creds['app_id'] : '');
	$fb_app_secret = (isset($creds['app_secret']) ? $creds['app_secret'] : '');
	$facebook_form_id = (isset($options['lead_form']['facebook']) ? $options['lead_form']['facebook'] : '');
	$link = "https://www.facebook.com/ads/lead_gen/export_csv/?id={$facebook_form_id}&type=form&source_type=graph_api";	
	return $link;
}

function pm_lead_book_aweber_handle_errors(&$exc) {
    // a simple way to display an API exception
    print "<h3>AWeberAPIException:</h3>";
    print " <li> Type: $exc->type              <br>";
    print " <li> Msg : $exc->message           <br>";
    print " <li> Docs: $exc->documentation_url <br>";
    print "<hr>";
}



?>
