<?php 

session_start();

require_once('../facebook/autoload.php');

$fb = new Facebook\Facebook([

  'app_id' => $_SESSION['facebook_app_id'],

  'app_secret' => $_SESSION['facebook_app_secret'],

  'default_graph_version' => 'v2.4',

]);



$helper = $fb->getRedirectLoginHelper();

try {

  $accessToken = $helper->getAccessToken();

} catch(Facebook\Exceptions\FacebookResponseException $e) {

  // When Graph returns an error

  echo 'Graph returned an error: ' . $e->getMessage();

  exit;

} catch(Facebook\Exceptions\FacebookSDKException $e) {

  // When validation fails or other local issues

  echo 'Facebook SDK returned an error: ' . $e->getMessage();

  exit;

}



if (isset($accessToken)) {

  // Logged in!

  $oAuth2Client = $fb->getOAuth2Client();

  $longLivedAccessToken = $oAuth2Client->getLongLivedAccessToken($accessToken);

  $_SESSION['facebook_access_token'] = (string) $longLivedAccessToken;

  header("Location: {$_SESSION['pm_lead_book_settings_url']}");

  exit;

} elseif ($helper->getError()) {

  // The user denied the request

}

?>