<?php 
add_action('init', 'pm_lead_book_start_session', 1);
function pm_lead_book_start_session() {
    if(!session_id()) {
        session_start();
    }
	
	$_SESSION['pm_lead_book_settings_url'] = pm_lead_book_settings_url();
}

/*
	* pm_lead_book_adminscripts
	* Enq Scripts and StyleSheets
	* FontAwesome: //maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css

*/

function pm_lead_book_register_settings() {
	add_menu_page(esc_html(sprintf(__( '%s', 'pm-lead-book' ), PM_LEAD_BOOK_PLUGIN_NAME)), esc_html(sprintf(__( '%s', 'pm-lead-book' ), PM_LEAD_BOOK_PLUGIN_NAME)), 'manage_options', 'pm_lead_book_settings', 'pm_lead_book_settings_page', '' );
	add_action('admin_init', 'pm_lead_book_settings_register_callback');
	
	add_submenu_page( 'pm_lead_book_settings', esc_html(__( 'MailChimp Integration', 'pm-lead-book' )), esc_html(__( 'MailChimp  Integration', 'pm-lead-book' )), 'manage_options', 'pm_lead_book_mailchimp', 'pm_lead_book_mailchimp_page' );
	add_submenu_page( 'pm_lead_book_settings', esc_html(__( 'Aweber Integration', 'pm-lead-book' )), esc_html(__( 'Aweber  Integration', 'pm-lead-book' )), 'manage_options', 'pm_lead_book_aweber', 'pm_lead_book_aweber_page' );
	
}
add_action( 'admin_menu', 'pm_lead_book_register_settings' );

/*
	* MailChimp Callback
*/

function pm_lead_book_settings_register_callback() {
	//register our settings
	register_setting( 'pm-lead-book-settings-group', PM_LEAD_BOOK_SETTINGS_OPTION, 'pm_lead_book_settings_validate');
}

/*
	* pm_lead_book_settings_validate
*/

function pm_lead_book_settings_validate($input) {
	$array = array();
	foreach($input as $key => $values) {
		if(is_array($input[$key])) {
			//$input[$key] = array_filter($input[$key]);
			if($input[$key]) {
				//$values = array_filter($values);
				if(is_array($values)){
					foreach($values as $vkey => $value) {
						$array[$key][$vkey] = wp_strip_all_tags($value,true);
					}
				}
			}
			
		}
	}
	return $array;
}

/*
	* Settings
*/
function pm_lead_book_settings_page() { ?>
	<div class="wrap pm_lead_book_form_login">
	<?php
	pm_lead_book_facebook_connect();
	pm_lead_book_aweber_connect();
	?>
	</div>
	<?php
	$setting_fields = pm_lead_book_setting_fields();
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	//wp_enqueue_style( 'pm-lead-book-font-awesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css', '', PM_LEAD_BOOK_VERSION, 'all' );
	wp_enqueue_style( 'pm-lead-book-bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css', '', PM_LEAD_BOOK_VERSION, 'all' );
	wp_enqueue_style( 'pm-lead-book-admin-style', PM_LEAD_BOOK_DIR.'modules/css/pm-lead-book.css', '', PM_LEAD_BOOK_VERSION, 'all' );
?>
	<div class="wrap">
		<form id="pm_lead_book_form" class="form-horizontal pm_lead_book_form" action="options.php" method='post'>
			<?php settings_fields( 'pm-lead-book-settings-group' ); ?>
			<?php do_settings_sections( 'pm-lead-book-settings-group' ); ?>
			<?php 
			foreach($setting_fields as $skey =>  $fields): 
			$visibility = (isset($options[$skey]['authorized']) && $options[$skey]['authorized'] == 1  ? ' style="display: none;" ' : '');
			?>
			<div <?php print $visibility; ?> id="social_<?php print $skey; ?>">
				<h3><?php print $fields['social_name']; ?></h3>
				<p class="description"><?php print $fields['general_description']; ?></p>		
				<fieldset>
					<?php foreach($fields['fields'] as $fkey => $field): 
					$default_value = $setting_fields[$skey]['fields'][$field['name']]['default'];
					$option = (isset($options[$skey][$fkey]) ? $options[$skey][$fkey] : $default_value);
					
					if($field['field'] == 'input' && pm_lead_book_set_field('type',$skey,$field['name']) == 'checkbox'): 
					$checked = ($option == 1 ? 'checked' : '');
					?>
					<div class="form-group">
						<label class="col-md-1 control-label" "><?php print $field['label']; ?>:</label> 
						<div class="col-md-10 checkbox">
							<label class="checkbox-inline" for="<?php print pm_lead_book_set_field('id',$skey,$field['name']); ?>"><input <?php print $checked; ?> type="<?php print pm_lead_book_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_lead_book_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_lead_book_set_field('id',$skey,$field['name']); ?>" value="1" class="form-control input-md fb_hcs_setting_field" /> <?php print pm_lead_book_set_field('description',$skey,$field['name']); ?></label> 
						</div>
					</div>
					<?php elseif($field['field'] == 'input' && pm_lead_book_set_field('type',$skey,$field['name']) != 'hidden'): ?>
					<div class="form-group">
						<label class="col-md-1 control-label" for="<?php print pm_lead_book_set_field('id',$skey,$field['name']); ?>"><?php print $field['label']; ?>:</label>
						<div class="col-md-5">
							<input type="<?php print pm_lead_book_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_lead_book_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_lead_book_set_field('id',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="form-control input-md fb_hcs_setting_field" />
							<span class="help-block"><?php print pm_lead_book_set_field('description',$skey,$field['name']); ?></span>
						</div>
					</div>
					<?php elseif(pm_lead_book_set_field('type',$skey,$field['name']) == 'hidden'): ?>
					<div class="form-group">
						<div class="col-md-1">
							<input type="<?php print pm_lead_book_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_lead_book_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_lead_book_set_field('id',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="form-control input-md fb_hcs_setting_field" />
						</div>
					</div>
					<?php else: ?>
					<div class="form-group">
						<label class="col-md-1 control-label" for="<?php print pm_lead_book_set_field('id',$skey,$field['name']); ?>"><?php print $field['label']; ?>:</label>
						<div class="col-md-3">
							<select name="<?php print pm_lead_book_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_lead_book_set_field('id',$skey,$field['name']); ?>" class="form-control fb_hcs_setting_field">
							<?php foreach($field['values'] as $select_value): ?>
							  <option <?php print ($option == $select_value ? 'selected' : '' ); ?> value="<?php print $select_value; ?>"><?php print $select_value; ?></option>
							<?php endforeach; ?>
							</select>
						</div>
					</div>
					<?php endif; //Not HIdden ?>
					<?php endforeach; ?>
				</fieldset>
			</div>
			<?php endforeach; ?>
			<?php submit_button( esc_html(__('Save Settings', 'pm-lead-bookr')), 'primary', 'pm_lead_book_submit', false, array('id' => 'pm_lead_book_submit') ); ?>
		</form>
	</div>
<?php
}


/*
	* pm_lead_book_mailchimp_page
	* MailChimp Page
*/

function pm_lead_book_mailchimp_page() {
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	wp_enqueue_style( 'pm-lead-book-font-awesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css', '', PM_LEAD_BOOK_VERSION, 'all' );
	wp_enqueue_style( 'pm-lead-book-bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css', '', PM_LEAD_BOOK_VERSION, 'all' );
	wp_enqueue_script( 'pm-lead-book-admin-script', PM_LEAD_BOOK_DIR.'modules/js/pm-lead-book.js', '', PM_LEAD_BOOK_VERSION );
	wp_enqueue_style( 'pm-lead-book-admin-style', PM_LEAD_BOOK_DIR.'modules/css/pm-lead-book.css', '', PM_LEAD_BOOK_VERSION, 'all' );
	$main_array = array(
		'ajaxurl' => admin_url( 'admin-ajax.php' )
	);
	wp_localize_script( 'pm-lead-book-admin-script', 'pm_lead_book', $main_array);
	
	
	$fb_status = pm_lead_book_login_status();
	$facebook_form_id = (isset($options['lead_form']['facebook']) ? $options['lead_form']['facebook'] : '');
	$mailchimp_form_id = (isset($options['lead_form']['mailchimp']) ? $options['lead_form']['mailchimp'] : '');
	if( $fb_status ): //Facebook is Logged-in
	$fb_leads_link = pm_lead_book_generate_link();
	$last_cron_run = get_option('_pm_lead_book_last_run_mailchimp');
	$next_cron_run = get_option('_pm_lead_book_next_run_mailchimp');
	
	?>
	<div id="lead_book_import_wrapper" class="wrap lead_book_integration_wrapper">
		<h3><?php esc_html(_e( 'MailChimp Integration', 'pm-lead-book' )); ?></h3>
		<table class="table" width="300">
			<tbody>
				<tr>
			    <th><?php esc_html(_e( 'MailChimp Form', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_form_id"><?php print $mailchimp_form_id; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Form ID', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_form_id"><?php print $facebook_form_id; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Last Cron Run', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_last_cron"><?php print $last_cron_run; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Next Cron Run', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_last_cron"><?php print $next_cron_run; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Download Link', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_link"><a href="<?php print $fb_leads_link; ?>" target="_blank"><?php esc_html(_e( 'Download CSV', 'pm-lead-book' )); ?></a></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Date', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_date">-</td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Total Leads', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_count">-</td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'New Leads Imported', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_processed">-</td>
			  </tr>
			</tbody>
		</table>
		<form class="lead_book_import_wrapper_form form-horizontal">
			<fieldset>
			<!-- Button (Double) -->
			<div class="button_wrapper form-group">
			  <div class="col-md-3">
			    <button id="pmp_lead_book_check_leads" name="pmp_lead_book_check_leads" class="btn btn-info"><?php esc_html(_e( 'Check Leads', 'pm-lead-book' )); ?></button>
			    <button style="display: none;" id="pmp_lead_book_import_mailchimp_leads" name="pmp_lead_book_import_mailchimp_leads" class="btn btn-success pmp_lead_book_import_leads"><?php esc_html(_e( 'Import Leads', 'pm-lead-book' )); ?></button>
			  </div>
			</div>
			
			<div class="loading_wrapper form-group" style="display: none;" >
			  <div class="col-md-2">
			  	<div class="alert alert-info" role="alert">
			  		<i class="fa fa-circle-o-notch fa-spin" ></i> <strong><?php esc_html(_e( 'Processing', 'pm-lead-book' )); ?></strong>
				</div>
			  </div>
			</div>

			</fieldset>
		</form>	
	</div> 
	<?php
	else: ?>
	<div id="lead_book_import_wrapper" class="wrap lead_book_integration_wrapper">
		<h3><?php esc_html(_e( 'MailChimp Integration', 'pm-lead-book' )); ?></h3>
		<p><?php esc_html(_e( 'You need to be logged-in to Facebook.', 'pm-lead-book' )); ?></p>
	</div>
	<?php
	endif; 
}

/*
	* pm_lead_book_aweber_page
	* Aweber Page
*/

function pm_lead_book_aweber_page() {
	$options = get_option(PM_LEAD_BOOK_SETTINGS_OPTION, array());
	wp_enqueue_style( 'pm-lead-book-font-awesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css', '', PM_LEAD_BOOK_VERSION, 'all' );
	wp_enqueue_style( 'pm-lead-book-bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css', '', PM_LEAD_BOOK_VERSION, 'all' );
	wp_enqueue_script( 'pm-lead-book-admin-script', PM_LEAD_BOOK_DIR.'modules/js/pm-lead-book.js', '', PM_LEAD_BOOK_VERSION );
	$main_array = array(
		'ajaxurl' => admin_url( 'admin-ajax.php' )
	);
	wp_localize_script( 'pm-lead-book-admin-script', 'pm_lead_book', $main_array);
	
	$fb_status = pm_lead_book_login_status();
	$aw_status = pm_lead_book_aweber_login_status();
	$facebook_form_id = (isset($options['lead_form']['facebook']) ? $options['lead_form']['facebook'] : '');
	$aweber_list_id = (isset($options['lead_form']['aweber']) ? $options['lead_form']['aweber'] : '');
	if( $fb_status && $aw_status ): //Facebook is Logged-in
	$fb_leads_link = pm_lead_book_generate_link();
	$last_cron_run = get_option('_pm_lead_book_last_run_aweber');
	$next_cron_run = get_option('_pm_lead_book_next_run_aweber');
	?>
	<div id="lead_book_import_wrapper" class="wrap lead_book_integration_wrapper">
		<h3><?php esc_html(_e( 'Aweber Integration', 'pm-lead-book' )); ?></h3>
		<table class="table" width="300">
			<tbody>
				<tr>
			    <th><?php esc_html(_e( 'Aweber Form', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_form_id"><?php print $aweber_list_id; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Form ID', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_form_id"><?php print $facebook_form_id; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Last Cron Run', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_last_cron"><?php print $last_cron_run; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Next Cron Run', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_last_cron"><?php print $next_cron_run; ?></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Download Link', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_link"><a href="<?php print $fb_leads_link; ?>" target="_blank"><?php esc_html(_e( 'Download CSV', 'pm-lead-book' )); ?></a></td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Date', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_date">-</td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'Total Leads', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_count">-</td>
			  </tr>
			  <tr>
			    <th><?php esc_html(_e( 'New Leads Imported', 'pm-lead-book' )); ?></th>
			    <td id="lead_book_fb_processed">-</td>
			  </tr>
			</tbody>
		</table>
		<form class="lead_book_import_wrapper_form form-horizontal">
			<fieldset>
			<!-- Button (Double) -->
			<div class="button_wrapper form-group">
			  <div class="col-md-3">
			    <button id="pmp_lead_book_check_leads" name="pmp_lead_book_check_leads" class="btn btn-info"><?php esc_html(_e( 'Check Leads', 'pm-lead-book' )); ?></button>
			    <button style="display: none;" id="pmp_lead_book_import_aweber_leads" name="pmp_lead_book_import_aweber_leads" class="btn btn-success pmp_lead_book_import_leads"><?php esc_html(_e( 'Import Leads', 'pm-lead-book' )); ?></button>
			  </div>
			</div>
			
			<div class="loading_wrapper form-group" style="display: none;" >
			  <div class="col-md-2">
			  	<div class="alert alert-info" role="alert">
			  		<i class="fa fa-circle-o-notch fa-spin" ></i> <strong><?php esc_html(_e( 'Processing', 'pm-lead-book' )); ?></strong>
				</div>
			  </div>
			</div>

			</fieldset>
		</form>
	</div>
	<?php
	else: ?>
	<div id="lead_book_import_wrapper" class="wrap lead_book_integration_wrapper">
		<h3><?php esc_html(_e( 'Aweber Integration', 'pm-lead-book' )); ?></h3>
		<p><?php esc_html(_e( 'You need to be logged-in to Aweber and Facebook.', 'pm-lead-book' )); ?></p>
	</div>
	<?php
	endif; 
}


